;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Master Hand
; by Ladida
; inspired by Schwa's
; Master Hand
;
; Setting the extra bit
; enables the secret exit
;
; Try not to edit
; anything :>
;
; I also tried to comment
; as much as I could, in
; case someone feels like
; copying routines/etc
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Safe to edit:

;;;;Before speed-up;;;;

!shootbefore = 3	;# of times Master Hand will shoot Bullet Bills
!inittimer = $F0	;time between attacks
!inithealth = 200	;Decimal ($96 hex). Health Master Hand starts with
			;	Will crash if it's past 255

;;;;After speed-up;;;;

!shootafter = 5		;# of times Master Hand will shoot Bullet Bills
!inittimer2 = $90	;time between attacks after health is past below value
!secondhealth = 100	;Decimal ($64 hex). Health Master Hand becomes "faster"
			;	Should be lower than !inithealth

!attackpose = $37	;Pose to use for basic attack (from $13E0)


;NOT safe to edit. Be careful if you do:

!maxheight = $0100		;Max height to go for Punch/Crush
!attackdistance = $0024		;Point at which Master Hand will end an attack
!initxpos = $00D0		;initial X Position
!initypos = $0130		;initial Y Position

!currentframe = $C2,x		;determines move to use
!idletimer = $1540,x		;general timer (disregard name)
!idletimer2 = $163E,x		;secondary timer
!framestate = $151C,x		;current state in move
!masterhealth = $1528,x		;health (Master Hand)
!misctable = $1534,x		;miscellaneous table
!disablecontact = $154C,x	;time to show hitting frame (Player)

!laser1 = $1570,x		;pointer to position of laser
!laser2 = $15AC,x		;timer to flip X Speed of Master Hand
!laser3 = $160E,x		;stores the laser's X position

!YSpeed = $AA,x
!XSpeed = $B6,x

!XPos_Low = $02
!XPos_High = $03
!YPos_Low = $04
!YPos_High = $05



;init

print "INIT ",pc
JSR SUB_HORZ_POS
TYA
STA $157C,x
LDA #$0E
STA !currentframe
STZ !framestate
LDA #!inittimer
STA !idletimer
JSR MasterPosition
REP #$20
LDA #!initxpos
STA !XPos_Low
LDA #!initypos
SEC : SBC #$0090
STA !YPos_Low
SEP #$20
JSR MasterPositionReload
LDA #$00
STA !misctable
LDA.b #!inithealth
STA !masterhealth
LDA #$00
STA !disablecontact
STA !laser1
STA !laser2
STA !laser3
LDA #$19
STA $1686,x
RTL


;main

print "MAIN ",pc
PHB : PHK : PLB
JSR MasterHand
PLB : RTL


;Master Hand code start

ReturnHand2:
JMP ReturnHand

MasterHand:
JSR MasterGraphics	;Graphics Routine
JSR Create_Percent	;Render Master Hand's health
LDA $14C8,x
CMP #$08
BNE ReturnHand2
LDA $9D
BNE ReturnHand2
JSR SUB_OFF_SCREEN_X0

LDA !currentframe
CMP #$0F		;If dying
BEQ +			;Then skip
JSR MasterPosition
REP #$20
LDA #!initypos
CLC : ADC #$0040	;If Master Hand is too low on the screen
CMP !YPos_Low
SEP #$20
BCS +
LDA #$01
STA $157C,x
STA !framestate		;Then stop current attack and go back to idle mode
LDA #$00
STA !currentframe
+

LDA !currentframe	;This is where the fun begins ^_^
JSL MasterPointer
dw MasterHand_Idle
dw MasterHand_Punch
dw MasterHand_Crush
dw MasterHand_Slap
dw MasterHand_Sweep
dw MasterHand_Walk
dw MasterHand_Grab
dw MasterHand_Poke
dw MasterHand_Drill
dw MasterHand_Gun
dw MasterHand_Lasers
dw MasterHand_Background_Slap	;unused
dw MasterHand_Background_Punch	;unused
dw MasterHand_Background_Jet	;unused
dw MasterHand_Entrance
dw MasterHand_Exit



MasterHand_Idle:	;Basically when it's safe to attack him
LDA #$00
STA $1656,x
LDA #$08
STA $1662,x
LDA #$19
STA $1686,x
LDA !framestate
BEQ +
JMP MasterHand_Origin
+
LDA $14
LSR #4 : AND #$01 : TAY
LDA .y_speed,y
STA !YSpeed
JSL $01802A
LDA !idletimer
BNE +
LDA #$09
JSL RandomRoutine
CLC : ADC #$01
STA !currentframe
LDA #$00
STA !framestate
+
JMP ReturnHand

.y_speed
db $02,$FE

MasterHand_Origin:	;Moving back to original X and Y
JSR MasterPosition
REP #$20
LDA !XPos_Low
CMP #!initxpos
BEQ +
BCC ++
LDA !XPos_Low
SEC : SBC #!initxpos
SEP #$20
LSR #4 : ASL : TAY
REP #$20
LDA !XPos_Low
SEC : SBC .xy_disp,y
STA !XPos_Low
BRA +++
++
LDA #!initxpos
SEC : SBC !XPos_Low
SEP #$20
LSR #4 : ASL : TAY
REP #$20
LDA !XPos_Low
CLC : ADC .xy_disp,y
STA !XPos_Low
BRA +++
+
SEP #$20
LDA !misctable
ORA #$01
STA !misctable
+++

REP #$20
LDA !YPos_Low
CMP #!initypos
BEQ +
BCC ++
LDA !YPos_Low
SEC : SBC #!initypos
SEP #$20
LSR #4 : ASL : TAY
REP #$20
LDA !YPos_Low
SEC : SBC .xy_disp,y
STA !YPos_Low
BRA +++
++
LDA #!initypos
SEC : SBC !YPos_Low
SEP #$20
LSR #4 : ASL : TAY
REP #$20
LDA !YPos_Low
CLC : ADC .xy_disp,y
STA !YPos_Low
BRA +++
+
SEP #$20
LDA !misctable
ORA #$02
STA !misctable
+++

SEP #$20
LDA !misctable
CMP #$03
BNE ++
LDY #!inittimer
LDA !masterhealth
CLC : ADC #$01
CMP.b #!secondhealth
BCS +
LDY #!inittimer2
+
TYA
STA !idletimer
LDA #$00
STA !framestate
STA !currentframe
STA !misctable
++
JSR MasterPositionReload
JMP ReturnHand

.xy_disp
dw $0001,$0002,$0003,$0004,$0005,$0006,$0007,$0008
dw $0009,$000A,$000B,$000C,$000D,$000E,$000F,$0010




MasterHand_Punch:		;Both are basically the same move
MasterHand_Crush:		;Just different graphics (and hitbox)
LDA !framestate
JSL MasterPointer
dw .init,.float,.smash1,.smash2

.init
JSR MasterPosition
REP #$20
LDA !YPos_Low
CMP #!maxheight
SEP #$20
BCS +
LDA #$01
STA !framestate
LDY #$30
LDA !masterhealth
CLC : ADC #$01
CMP.b #!secondhealth
BCS ++
LDY #$18
++
TYA
STA !idletimer
+
LDA #$E0
STA !YSpeed
JSR SUB_LOCKONX
JSL $01802A
JMP ReturnHand

.float
LDA #$00
STA !YSpeed
JSR SUB_LOCKONX
JSL $01802A
LDA !idletimer
BNE +
LDA #$02
STA !framestate
LDA #$30
STA !idletimer
+
JMP ReturnHand

.smash1
LDY #$08
LDA !currentframe
CMP #$02
BNE +
LDY #$1F
+
TYA
JSR HurtPlayer
LDA #$00
STA $1656,x
LDA $1588,x
AND #$04
BNE +
LDY #$50
LDA !currentframe
CMP #$01
BNE ++
LDY #$60
++
TYA : STA !YSpeed
LDA #$00 : STA !XSpeed
JSL $01802A
JMP ReturnHand
+
LDA #$00
JSR StompSmoke
LDA #$09
STA $1DFC
LDA #$03
STA !framestate
LDA #$00
STA !YSpeed
JSL $01802A
JMP ReturnHand

.smash2
LDA !idletimer
BNE ++
JMP Prereturn
++
JMP ReturnHand


MasterHand_Slap:
LDA !framestate
JSL MasterPointer
dw .superinit,.init,.slap

.superinit
LDA #$20
STA !idletimer
LDA #$01
STA !framestate
JMP ReturnHand

.init
LDA !idletimer
BNE +
LDA #$02
STA !framestate
+
LDA #$08
STA !XSpeed
STZ !YSpeed
JSL $01802A
JMP ReturnHand

.slap
JSR EndAttack
LDA #$10
STA $1662,x
JSL $01A7DC
BCC +
LDA #$C0
STA $7B
+
LDA #$01
STA $1656,x
JSR MasterPosition
REP #$20
LDA !XPos_Low
CMP #!initxpos
BCC +
LDY #$1E
STY $1DF9
+
SEP #$20
LSR #5
TAY
LDA .slaptable,y
STA !XSpeed
LDA $1588,x
AND #$04
BNE +
LDA #$40
STA !YSpeed
BRA ++
+
LDA #$00
STA !YSpeed
++
JSL $01802A
JMP ReturnHand

.slaptable
db $C8,$C0,$B8,$B0,$B0,$B8,$C0,$C8


MasterHand_Sweep:
LDA !framestate
JSL MasterPointer
dw .superinit,.init,.sweep1,.sweep2

.superinit
LDA #$10
STA !idletimer
LDA #$01
STA !framestate
JMP ReturnHand

.init
LDA !idletimer
BNE +
LDA #$02
STA !framestate
LDA #$10
STA !idletimer
+
LDA #$10
STA !XSpeed
STZ !YSpeed
JSL $01802A
JMP ReturnHand

.sweep1
JSR EndAttack
LDA !idletimer
BNE +
LDA #$03
STA !framestate
LDA #$10
STA !idletimer
+
LDA #$08
STA $1662,x
LDA #$00
STA $1656,x
LDA #$F0
STA !XSpeed
LDA $1588,x
AND #$04
BNE +
LDA #$38
STA !YSpeed
BRA ++
+
LDA #$00
STA !YSpeed
++
JSL $01802A
JMP ReturnHand

.sweep2
JSR EndAttack
LDA !idletimer
BNE +
LDA #$02
STA !framestate
LDA #$10
STA !idletimer
+
LDA #$29
JSR HurtPlayer
LDA #$00
STA $1656,x
LDA #$09
STA $1DF9
LDA #$D0
STA !XSpeed
LDA $1588,x
AND #$04
BNE +
LDA #$38
STA !YSpeed
BRA ++
+
LDA #$00
STA !YSpeed
++
JSL $01802A
JMP ReturnHand


MasterHand_Walk:
LDA !framestate
JSL MasterPointer
dw .init,.walk1,.walk2,.kick

.init
LDA #$01
STA $1656,x
LDA #$10
STA $1662,x
LDA $1588,x
AND #$04
BNE +
LDA #$10
STA !YSpeed
LDA #$00
STA !XSpeed
JSL $01802A
JMP ReturnHand
+
LDA #$01
STA !framestate
LDA #$08
STA !idletimer
JMP ReturnHand

.walk1
JSR EndAttack
JSL $01A7DC
BCC +
LDA #$10
STA !idletimer
LDA #$03
STA !framestate
LDY #$B0
LDA !masterhealth
CLC : ADC #$01
CMP.b #!secondhealth
BCS ++
LDY #$50
++
TYA
STA $7B
LDA #$B0
STA $7D
JMP ReturnHand
+
LDA !idletimer
BNE +
LDA #$02
STA !framestate
LDA #$08
STA !idletimer
+
LDA #$09
STA $1DFC
LDA #$E8
STA !XSpeed
JSL $01802A
JMP ReturnHand

.walk2
JSR EndAttack
JSL $01A7DC
BCC +
LDA #$10
STA !idletimer
LDA #$03
STA !framestate
LDY #$B0
LDA !masterhealth
CLC : ADC #$01
CMP.b #!secondhealth
BCS ++
LDY #$50
++
TYA
STA $7B
LDA #$B0
STA $7D
JMP ReturnHand
+
LDA !idletimer
BNE +
LDA #$01
STA !framestate
LDA #$08
STA !idletimer
+
LDA #$E8
STA !XSpeed
JSL $01802A
JMP ReturnHand

.kick
LDA !idletimer
BNE +
JMP Prereturn
+
LDA #$00
STA !XSpeed
LDA #$13
STA $1DF9
JSL $01802A
JMP ReturnHand


MasterHand_Grab:
LDA !framestate
JSL MasterPointer
dw .grab1,.grab2,.release

.grab1
JSR EndAttack
LDA #$10
STA $1662,x
LDA #$99
STA $1686,x
LDA !masterhealth
CLC : ADC #$01
CMP.b #!secondhealth
BCS ++
JSR SUB_LOCKONY2
BRA +
++
JSR SUB_LOCKONY
+
LDA #$F3
STA !XSpeed
JSL $01802A
JSL $01A7DC
BCC +
LDA #$80
STA !idletimer
LDA #$01
STA !framestate
+
JMP ReturnHand

.grab2
LDA !misctable
CMP #$1F
BEQ +++
LDA !idletimer
BEQ +
LDA #$00
STA !YSpeed
STA !XSpeed
JSL $01802A
LDA #$7F
STA $78
STZ $7B
STZ $7D
LDA $14
AND #$0F
BNE ++
LDA #$07
STA $1DFC
++
LDA $16
BEQ ++
LDA !misctable
INC
STA !misctable
++
JMP ReturnHand
+
JSL $00F5B7
+++
LDA #$02
STA !framestate
LDA #$20
STA !idletimer
JMP ReturnHand

.release
LDA !idletimer
BNE +
JMP Prereturn
+
LDA #$00
STA $78
JMP ReturnHand



MasterHand_Poke:
LDA !framestate
JSL MasterPointer
dw .init,.charge,.poke1,.poke2

.init
LDA #$50
STA !idletimer
LDA #$01
STA !framestate
JMP ReturnHand

.charge
LDA !idletimer
BNE +
LDA #$02
STA !framestate
LDA #$08
STA !idletimer
+
JSR SUB_LOCKONY
JSR SUB_LOCKONX
JSL $01802A
LDA $14
AND #$03
BNE +
JSL $0285BA
+
LDA #$15
STA $1DFC
JMP ReturnHand

.poke1
LDA !idletimer
BNE +
INC !misctable
LDA #$03
STA !framestate
LDA #$20
STA !idletimer
+
LDA #$2A
JSR HurtPlayer
LDA #$03
STA $1DF9
LDA #$40
STA !YSpeed
LDA #$C0
STA !XSpeed
JSL $01802A
JMP ReturnHand

.poke2
LDA !idletimer
BNE ++
LDA !misctable
CMP #$03
BCS +
LDA #$02
STA !framestate
LDA #$08
STA !idletimer
+
JMP Prereturn
++
LDA #$F0
STA !YSpeed
LDA #$10
STA !XSpeed
JSL $01802A
JMP ReturnHand


MasterHand_Drill:
LDA !framestate
JSL MasterPointer
dw .rise,.fall,.drill

.rise
LDA #$01
STA !misctable
JSR SUB_IS_OFFSCREEN
BEQ +
LDA #$01
STA !framestate
JSR MasterPosition
REP #$20
LDA $D1
STA !XPos_Low
SEP #$20
JSR MasterPositionReload
+
LDA $157C,x
EOR #$01
STA $157C,x
LDA #$D0
STA !YSpeed
LDA #$F0
STA !XSpeed
JSL $01802A
LDA #$16
STA $1DFC
JMP ReturnHand

.fall
JSL $01A7DC
BCC +
STZ $7B
LDA #$20
STA $7D
LDA #$01
STA $140D
+
LDA $157C,x
EOR #$01
STA $157C,x
LDA #$01
STA $1656,x
LDA #$10
STA $1662,x
LDA $1588,x
AND #$04
BNE +
LDA #$00
STA !XSpeed
LDA #$60
STA !YSpeed
JSL $01802A
JMP ReturnHand
+
LDA #$00
STA !YSpeed
JSL $01802A
LDA #$02
STA !framestate
LDA #$81
STA !idletimer
JMP ReturnHand

.drill
JSL $01A7DC
BCC +
STZ $7B
LDA $72
BNE ++
LDA #$FF
STA $7D
BRA +++
++
STZ $7D
+++
LDA #$01
STA $140D
LDA !idletimer
CMP #$04
BCS +
LDA $1497
ORA $187A
ORA $15D0,x
BNE +
JSL $00F5B7
+
LDA !idletimer
BNE +
LDA #$01
STA $157C,x
JMP Prereturn
+
CMP #$40
BCS ++
CMP #$10
BCS +++
LDY #$12
STY $1DFC
+++
LSR #4
AND #$03
TAY
LDA $14
AND .fliptable,y
BNE +
BRA +++
++
LDA #$11
STA $1DFC
LDA #$01
JSR StompSmoke
+++
LDA $157C,x
EOR #$01
STA $157C,x
+
JMP ReturnHand

.fliptable
db $0F,$07,$03,$01


MasterHand_Gun:
LDA !framestate
JSL MasterPointer
dw .init,.follow,.shoot,.recoil

.init
LDY.b #!shootbefore
LDA !masterhealth
CLC : ADC #$01
CMP.b #!secondhealth
BCS +
LDY.b #!shootafter
+
TYA : STA !misctable
LDA #$30
STA !idletimer
LDA #$01
STA !framestate
JMP ReturnHand

.follow
LDA !idletimer
BNE +
LDA #$02
STA !framestate
JMP ReturnHand
+
LDA #$07
STA !XSpeed
LDA #$10
STA !YSpeed
JSL $01802A
JMP ReturnHand

.shoot
LDA !idletimer
BEQ +
JMP ReturnHand
+
LDA !misctable
BNE +
JMP Prereturn
+
LDA #$00
JSR SUB_BULLET_SHOOT
LDA #$00
JSR SUB_SMOKE
LDA #$12
JSR SUB_BULLET_SHOOT
LDA #$12
JSR SUB_SMOKE
LDA #$17
STA $1DFC
LDA #$03
STA !framestate
LDA #$10
STA !idletimer
LDA !misctable
DEC A
STA !misctable
JMP ReturnHand

.recoil
LDA !idletimer
BNE +
LDA #$02
STA !framestate
LDA #$18
STA !idletimer
+
JMP ReturnHand


MasterHand_Lasers:
LDA !framestate
JSL MasterPointer
dw .init,.charge,.laser

.init
JSR MasterPosition
REP #$20
LDA #!initypos
CLC : ADC #$0006
STA !YPos_Low
SEP #$20
JSR MasterPositionReload
LDA #$60
STA !idletimer
LDA #$01
STA !framestate
LDA #$0E
STA !laser1
JMP ReturnHand

.charge
LDA !idletimer
BNE +
LDA #$02
STA !framestate
LDA #$FF
STA !idletimer
LDA #$70
STA !laser2
+
LDA #$F9
STA !XSpeed
LDA #$00
STA !YSpeed
JSL $01802A
LDA #$15
STA $1DFC
JMP ReturnHand

.laser
LDA !idletimer
BNE +
LDA !idletimer2
BNE ++
JMP Prereturn
+
LDA #$FF
STA !idletimer2
++
LDA $14
AND #$01
BEQ +
LDA #$0A
STA $1DFC
+
LDA #$00
STA !YSpeed
LDA !laser2
BNE +
LDA !XSpeed
EOR #$FF
SEC : SBC #$01
STA !XSpeed
LDA #$70
STA !laser2
+
JSL $01802A
JSR Create_Laser
LDA $94
CLC : ADC #$04
CMP !laser3
BCC +
SEC : SBC #$09
CMP !laser3
BCS +
LDA $77
AND #$04
BEQ +
JSL $00F5B7
+
JMP ReturnHand


MasterHand_Background_Slap:
JMP Prereturn

MasterHand_Background_Punch:
JMP Prereturn

MasterHand_Background_Jet:
JMP Prereturn

MasterHand_Entrance:
LDA #$01
STA !misctable
LDA $14 : AND #$01 : BNE ++
JSR MasterPosition
REP #$20
LDA !YPos_Low
CLC : ADC #$0001
STA !YPos_Low
CMP #!initypos
SEP #$20
BCC +
JSR MasterPositionReload
LDA #$00
STA !currentframe
STA !framestate
JMP Prereturn
+
JSR MasterPositionReload
++
JMP ReturnHand


MasterHand_Exit:
LDA !framestate
JSL MasterPointer
dw .die,.classic_mode_clear

.die
LDA #$29
STA $1DFC
LDA #$99
STA $1686,x
LDA #$00
STA !XSpeed
STA !YSpeed
LDA !idletimer
BNE +
LDA #$01
STA !framestate
LDA #$30
STA !idletimer
LDA #$E0
STA !YSpeed
+
JSL $01802A
RTS

.classic_mode_clear
LDA !idletimer
BNE +
JSR SUB_IS_OFFSCREEN
BEQ +
LDA #$02
STA $14C8,x
LDA #$FF
STA $1493
LDA $7FAB10,x
AND #$01
BEQ ++
LDA #$01
STA $141C
++
LDA #$0B
STA $1DFB
DEC $13C6
+
LDA #$20
STA !XSpeed
JSL $01802A
RTS



ReturnHand:		;How to hurt Master Hand
LDA !disablecontact
BEQ +
LDA #!attackpose
STA $13E0
+
JSL $01A7DC
BCC +
LDA !misctable
BNE +
LDA !disablecontact
BNE +
LDA $16
AND #$40
BEQ +
LDA #$02
STA $1DF9
LDA #$04
JSL RandomRoutine
CLC : ADC #$02
STA $00
LDA $14
CMP #$69
BNE ++
LDA #$0B
STA $00
++
LDA !masterhealth
SEC : SBC $00
CMP.b #!inithealth
BCC ++
LDA #$00
++
STA !masterhealth
LDA #$20
STA !disablecontact
+

LDA !masterhealth
BNE +
LDA #$0F
STA !currentframe
LDA #$00
STA !framestate
LDA #$40
STA !idletimer
+
RTS



EndAttack:	;Deals with Master Hand being on the far left of the stage
JSR MasterPosition
REP #$20
LDA !XPos_Low
CMP #!attackdistance
SEP #$20
BCS +
PLA : PLA
JMP Prereturn
+
RTS


Prereturn:	;Subroutine that helps return Master Hand to the original X and Y
LDA !XSpeed
BNE +
LDA #$00
STA !currentframe
LDA #$01
STA !framestate
LDA #$00
STA !misctable
STA !laser1
STA !laser2
STA !laser3
JMP ReturnHand
+
LDA #$E8
STA !YSpeed
LDA !XSpeed
CLC : ADC #$0C
STA !XSpeed
BMI +
LDA #$00
STA !XSpeed
+
JSL $01802A
JMP ReturnHand


HurtPlayer:	;Subroutine that helps to hurt the player
STA $1662,x	;Accumulator must have hitbox size
JSL $01A7DC
BCC +
LDA $1497
ORA $187A
ORA $15D0,x
BNE +
JSL $00F5B7
+
RTS

MasterPosition:		;Loads the X and Y positions into scratch RAM for ease
LDA $E4,x
STA !XPos_Low
LDA $14E0,x
STA !XPos_High
LDA $D8,x
STA !YPos_Low
LDA $14D4,x
STA !YPos_High
RTS
MasterPositionReload:	;Reloads the X and Y positions from scratch RAM
LDA !XPos_Low
STA $E4,x
LDA !XPos_High
STA $14E0,x
LDA !YPos_Low
STA $D8,x
LDA !YPos_High
STA $14D4,x
RTS


MasterPointer:
STY $03			;Save Y
PLY : STY $00		;Low byte
REP #$30
AND #$00FF : ASL : TAY	;Index
PLA : STA $01		;High and Bank byte
INY			;Position of JSL + $1
LDA [$00],y : STA $00
SEP #$30
LDY $03 : JMP [$0000]	;Reload Y and jump




;;;;;
;GFX Routine
;;;;;

MasterHandPoint:
db $00,$00,$00,$00	;idle, origin,null,null
db $06,$06,$06,$06	;init,hover,punch,ground
db $06,$06,$0A,$0A	;init,hover,smash,ground
db $0D,$0D,$0D,$00	;superinit,init,slap,null
db $10,$10,$10,$14	;superinit,init,sweep1,sweep2
db $18,$18,$1E,$24	;init,walk1,walk2,kick
db $29,$2F,$29,$00	;grab1,grab2,letgo,null
db $33,$33,$33,$33	;init,charge,poke1,poke2
db $44,$38,$38,$00	;rise,fall,drill,null
db $50,$50,$50,$56	;init,follow,shoot,recoil
db $00,$00,$00,$00	;init,charge,laser,null
db $00,$00,$00,$00	;
db $00,$00,$00,$00	;
db $00,$00,$00,$00	;
db $00,$00,$00,$00	;start
db $29,$29,$29,$29	;end
MasterHandPoint2:
db $05,$05,$05,$05	;idle, origin,null,null
db $09,$09,$09,$09	;init,hover,punch,ground
db $09,$09,$0C,$0C	;init,hover,smash,ground
db $0F,$0F,$0F,$05	;superinit,init,slap,null
db $13,$13,$13,$17	;superinit,init,sweep1,sweep2
db $1D,$1D,$23,$28	;init,walk1,walk2,kick
db $2E,$32,$2E,$05	;grab1,grab2,letgo,null
db $37,$37,$37,$37	;init,charge,poke1,poke2
db $49,$3D,$3D,$05	;rise,fall,drill,null
db $55,$55,$55,$5A	;init,follow,shoot,recoil
db $05,$05,$05,$05	;init,charge,laser,null
db $05,$05,$05,$05	;
db $05,$05,$05,$05	;
db $05,$05,$05,$05	;
db $05,$05,$05,$05	;start
db $2E,$2E,$2E,$2E	;end

MasterHandGFX:
db $00,$02,$04,$10,$12,$14	;idle,laser
db $06,$08,$26,$28		;fist
db $0A,$0C,$0E			;smash
db $2A,$2C,$2E			;slap
db $4C,$4E,$6C,$6E		;sweep1
db $48,$4A,$68,$6A		;sweep2
db $30,$31,$50,$51,$60,$61	;walk1
db $30,$31,$53,$54,$63,$64	;walk2
db $30,$31,$33,$46,$56		;kick
db $80,$82,$A0,$A2,$B0,$B2	;grab1
db $84,$86,$A4,$A6		;grab2
db $88,$89,$A8,$A9,$6A		;poke
db $8D,$8E,$AD,$AE,$CD,$CE	;drill1
db $8D,$8E,$AD,$AE,$CD,$CE	;drill2
db $8D,$8E,$AD,$AE,$CD,$CE	;drill3
db $8D,$8E,$AD,$AE,$CD,$CE	;drill4
db $D0,$D2,$D4,$AB,$E2,$E4	;gun1
db $C6,$C8,$E6,$E8,$8B		;gun2

MasterHandXPos:
db $F0,$00,$10,$F0,$00,$10	;idle,laser
db $F8,$08,$F8,$08		;fist
db $F0,$00,$10			;smash
db $00,$00,$00			;slap
db $F8,$08,$F8,$08		;sweep1
db $F8,$08,$F8,$E8		;sweep2
db $FC,$04,$FC,$04,$FC,$04	;walk1
db $FC,$04,$FC,$04,$FC,$04	;walk2
db $FC,$04,$F4,$04,$04		;kick
db $F6,$06,$F6,$06,$F6,$06	;grab1
db $F6,$06,$F6,$06		;grab2
db $08,$10,$08,$10,$F8		;poke
db $03,$FB,$03,$FB,$03,$FB	;drill1
db $FD,$05,$FD,$05,$FD,$05	;drill2
db $03,$FB,$03,$FB,$03,$FB	;drill3
db $FD,$05,$FD,$05,$FD,$05	;drill4
db $F0,$00,$10,$00,$00,$10	;gun1
db $00,$10,$00,$10,$00		;gun2

MasterHandYPos:
db $F8,$F8,$F8,$00,$00,$00	;idle,laser
db $F2,$F2,$02,$02		;fist
db $00,$00,$00			;smash
db $F0,$00,$10			;slap
db $EC,$EC,$FC,$FC		;sweep1
db $EC,$EC,$FC,$FC		;sweep2
db $F8,$F8,$08,$08,$10,$10	;walk1
db $F8,$F8,$08,$08,$10,$10	;walk2
db $F8,$F8,$08,$08,$10		;kick
db $F8,$F8,$08,$08,$10,$10	;grab1
db $F8,$F8,$08,$08		;grab2
db $EC,$EC,$FC,$FC,$FC		;poke
db $F0,$F0,$00,$00,$10,$10	;drill1
db $F0,$F0,$00,$00,$10,$10	;drill2
db $10,$10,$00,$00,$F0,$F0	;drill3
db $10,$10,$00,$00,$F0,$F0	;drill4
db $F8,$F8,$F8,$E8,$00,$00	;gun1
db $F0,$F0,$00,$00,$E0		;gun2


MasterGraphics:
JSR GET_DRAW_INFO	;y = oam, $00 = xpos, $01 = ypos
LDA $157C,x
STA $02			;$02 = direction

LDA $15F6,x
PHX
LDX $02
BNE +
ORA #$40
+
PLX
ORA $64
STA $04

LDA !currentframe
ASL #2
CLC : ADC !framestate
PHX : TAX
LDA MasterHandPoint,x
STA $05
LDA MasterHandPoint2,x
TAX : XBA : PLX
LDA !currentframe
CMP #$08		;If not Drill
BNE ++			;skip
LDA !framestate		;If initializing
BNE +++			;skip
LDA $04			;I have no clue what I did from here on :X
EOR #$80
STA $04
+++
LDA $02
BEQ +++
PHX : XBA : CLC : ADC #$06 : TAX
LDA $05 : CLC : ADC #$06 : STA $05
LDA #$40
TRB $04
BRA +
+++
LDA #$40
TSB $04
++
PHX : XBA : TAX
+			;But it somehow works!
-
LDA MasterHandGFX,x
STA $0302,y
LDA MasterHandXPos,x
CLC : ADC $00
STA $0300,y
LDA MasterHandYPos,x
CLC : ADC $01
STA $0301,y
LDA $04
STA $0303,y
INY #4 : DEX : CPX $05
BPL -
PLX

LDY #$02	;16x16
LDA #$05	;6 tiles (not all are always visible)
JSL $01B7B3
RTS




;;;;;;;;;;;;;;;;;;;;;;;;;
;Stomp Smoke subroutine
;;;;;;;;;;;;;;;;;;;;;;;;;

StompSmoke:
ASL : STA $00	;Accumulator must be either 00 or 01
LDA $1697
BNE .skip
PHY
JSR SmokeSpriteGen
PLY
.skip
RTS


SmokeXPosLow:
db $10,$F0,$08,$F8
SmokeXPosHigh:
db $00,$FF,$00,$FF
SmokeYPosLow:
db $04,$04,$14,$14
SmokeXSpeed:
db $18,$E8,$18,$E8

SmokeSpriteGen:
LDA #$05
STA $1887
JSR +
INC $00
+
LDY #$07
-
LDA $170B,y
BEQ +
DEY
BPL -
RTS
+
LDA #$0F
STA $170B,y
LDA $D8,x
PHX : LDX $00
CLC : ADC SmokeYPosLow,x
STA $1715,y
PLX
LDA $14D4,x
STA $1729,y
LDA $E4,x
PHX : LDX $00
CLC : ADC SmokeXPosLow,x
STA $171F,y
PLX
LDA $14E0,x
PHX : LDX $00
ADC SmokeXPosHigh,x
STA $1733,y
LDA SmokeXSpeed,x
STA $1747,y
LDA #$15
STA $176F,y
PLX
RTS




;;;;;;;;;;;;;;;;;;;;;;;;;
;Smoke subroutine
;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_SMOKE:
XBA
LDY #$03
-
LDA $17C0,y
BEQ +
DEY
BPL -
RTS
+
LDA #$01
STA $17C0,y
LDA $E4,x
SEC : SBC #$10
STA $17C8,y
XBA
CLC : ADC $D8,x
SEC : SBC #$10
STA $17C4,y
RTS




;;;;;;;;;;;;;;;;;;;;;;;;;
;Bullet subroutine
;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_BULLET_SHOOT:
XBA
LDA $15A0,x
ORA $186C,x
ORA $15D0,x
BEQ +
-
RTS
+
JSL $02A9DE
BMI -

LDA #$1C	;Bullet Bill
STA $009E,y

LDA $E4,x
SEC : SBC #$10
STA $00E4,y
LDA $14E0,x
STA $14E0,y
XBA
CLC : ADC $D8,x
SEC : SBC #$10
STA $00D8,y
LDA $14D4,x
STA $14D4,y

PHX : TYX
JSL $07F7D2
PLX
LDA #$01
STA $14C8,y
RTS




Create_Laser:		;Renders Master Hand's laser
			;they were a pain to code
			;and the code is a pain to look at
LDA !laser1 : STA $06

LDA $14 : AND #$01
BNE ++
LDA $06 : CMP #$80 : BCS +
INC A : STA $06 : CMP #$0F : BCC ++ : LDA #$8E : STA $06 : BRA ++
+
DEC A : STA $06 : CMP #$80 : BCS ++ : LDA #$00 : STA $06
++

JSR MasterPosition
PHY : PHX : STX $07

;LDX #$14 : LDY #$D4
LDY #$00 : LDA $06 : BPL + : LDY #$01
+
EOR .eortable,y : STA $01 : TAX : LDY #$02
CMP #$07 : BCS +
LDY #$03
+
LDA .laserxfinal,x : EOR .eortable,y : STA $00
LDX #$06 : LDY #$18
-
PHX : LDX $01
LDA $02
SEC : SBC #$13
CLC : ADC $00
ADC .xtable,x
STA $0230,y

CPY #$18 : BCC +
LDX $07 : STA !laser3
+

LDX $01
LDA $00
SEC : SBC .laserxadd,x
STA $00 : PLX

LDA $04
CLC : ADC .lasery,x
ADC #$48
STA $0231,y

PHX : LDX $01
LDA .laserframes,x
STA $0232,y
TXA
LDX #$01 : CMP #$07 : BCS + : LDX #$00
+
LDA .laserprops,x
STA $0233,y
PLX : DEY #4 : DEX : BPL -

LDA #$00
;STA $0429	occupied by
;STA $042A	some random
;STA $042B	smoke tiles

STA $042C
STA $042D
STA $042E
STA $042F
STA $0430
STA $0431

PLX : PLY
LDA $06 : STA !laser1
RTS

.eortable
db $00,$80,$00,$FF
.xtable
db $00,$02,$04
db $04,$06,$08
db $0C,$0D,$0E
db $12,$14,$16
db $16,$18,$1A
.laserxfinal
db $2A,$2A,$2A
db $15,$15,$15
db $06,$00,$06
db $15,$15,$15
db $2A,$2A,$2A
.laserxadd
db $F9,$F9,$F9
db $FC,$FC,$FC
db $FF,$00,$01
db $04,$04,$04
db $07,$07,$07
.lasery
db $00,$07,$0E,$15,$1C,$23,$2A
.laserframes
db $FC,$FC,$FC
db $FA,$FB,$FA
db $F0,$F0,$F0
db $FB,$FA,$FB
db $FC,$FC,$FC
.laserprops
db $37,$77




Create_Percent:		;Renders Master Hand's health
LDA !masterhealth
STA $00
PHY : PHX

;icon & percent sign
LDX #$02 : LDY #$08
-
LDA .miscx,x
STA $0200,y
LDA .miscy,x
STA $0201,y
LDA .misctile,x
STA $0202,y
LDA .miscprop,x
STA $0203,y
DEY #4 : DEX : BPL -

;hex to dec (A=ones,X=tens,Y=hundreds)
;Accumulator must initially have value to convert
;Only works for $00-$FF (0-255)
LDA $00
LDX #$00 : LDY #$00
-
CMP #10
BCC +
SBC #10
INX : CPX #10
BCC ++
PHA : TXA
SBC #10
TAX : PLA
INY : CPY #10
BCC ++
LDY #$00
++
BRA -
+

;hundreds
XBA : PHX : TYA
BNE +
LDA #$0A
+
TAX
LDA #$D8
STA $020C
LDA #$C8
STA $020D
LDA .toptile,x
STA $020E
LDA .topprop,x
STA $020F
LDA #$D8
STA $0210
LDA #$D0
STA $0211
LDA .bottomtile,x
STA $0212
LDA .bottomprop,x
STA $0213

;tens
PLX : CPY #$00
BNE +
CPX #$00
BNE +
LDX #$0A
+
LDA #$E0
STA $0214
LDA #$C8
STA $0215
LDA .toptile,x
STA $0216
LDA .topprop,x
STA $0217
LDA #$E0
STA $0218
LDA #$D0
STA $0219
LDA .bottomtile,x
STA $021A
LDA .bottomprop,x
STA $021B

;ones
XBA : TAX
LDA #$E8
STA $021C
LDA #$C8
STA $021D
LDA .toptile,x
STA $021E
LDA .topprop,x
STA $021F
LDA #$E8
STA $0220
LDA #$D0
STA $0221
LDA .bottomtile,x
STA $0222
LDA .bottomprop,x
STA $0223


LDA #$00	;I should learn to STZ
STA $0420
STA $0421
STA $0422
STA $0423
STA $0424
STA $0425
STA $0426
STA $0427
STA $0428
PLX : PLY
RTS

.misctile
db $FE,$FD,$FD
.miscprop
db $33,$33,$F3
.miscx
db $D8,$F2,$F2
.miscy
db $C0,$C8,$D0

.toptile
db $CA,$CB,$DA,$DA,$DC,$EB,$ED,$EE,$EF,$CA,$FF	;0,1,2,3,4,5,6,7,8,9,blank
.bottomtile
db $CA,$CC,$DB,$DA,$EA,$EC,$CA,$CC,$EF,$ED,$FF	;0,1,2,3,4,5,6,7,8,9,blank
.topprop
db $33,$33,$33,$33,$33,$33,$33,$33,$33,$33,$33	;0,1,2,3,4,5,6,7,8,9,blank
.bottomprop
db $B3,$33,$33,$B3,$33,$33,$B3,$33,$B3,$F3,$33	;0,1,2,3,4,5,6,7,8,9,blank



;; Random routine by 1024 (with a segment by wiiquertyuiop)
;; How to use:
;; LDA an 8-bit number which will be the maximum output
;; The output will be in the accumulator after execution of the routine

RandomRoutine:
PHX : PHP
SEP #$30
PHA
JSL $01ACF9		;Random number generation routine
LDA $2137
ADC $213C
ADC $13
ADC $148D
EOR #$FF
SBC $94
CLC : ADC $14
SBC $3F
STA $148D
ORA $14
EOR $148D
ADC $148E
STA $148E
PLX
CPX #$FF		;\ Handle glitch if max is FF
BNE normalrt		;|
LDA $148D		;|
BRA EndRandRoutine	;/
normalrt:
INX			; Amount in plus 1
LDA $148D		;\
STA $4202		;| Multiply with hardware regsisters
STX $4203		;|
NOP #4			;/
LDA $4217
EndRandRoutine:
PLP : PLX
RTL


;;;
;Vertical Lock-On Subroutine
;;;

y_EOR:
db $00,$80

y_EOR2:
db $00,$00

SUB_LOCKONY:
JSR SUB_VERT_POS
LDA $0F
LSR
ORA y_EOR,y
STA !YSpeed
RTS

SUB_LOCKONY2:
JSR SUB_VERT_POS
LDA $0F
;LSR 
;ORA y_EOR,y
STA !YSpeed
RTS


;;;
;Horizontal Lock-On Subroutine
;;;

x_EOR:
db $00,$80

SUB_LOCKONX:
JSR SUB_HORZ_POS
LDA $0F
LSR
ORA x_EOR,y
STA !XSpeed
RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B75C

TABLE1:
db $0C,$1C
TABLE2:
db $01,$02

GET_DRAW_INFO:
STZ $186C,x		; reset sprite offscreen flag, vertical
STZ $15A0,x		; reset sprite offscreen flag, horizontal
LDA $E4,x		; \
CMP $1A			;  | set horizontal offscreen if necessary
LDA $14E0,x		;  |
SBC $1B			;  |
BEQ ON_SCREEN_X		;  |
INC $15A0,x		; /

ON_SCREEN_X:
LDA $14E0,x		; \
XBA			;  |
LDA $E4,x		;  |
REP #$20		;  |
SEC			;  |
SBC $1A			;  | mark sprite invalid if far enough off screen
CLC			;  |
ADC.w #$0040		;  |
CMP.w #$0180		;  |
SEP #$20		;  |
ROL A			;  |
AND #$01		;  |
STA $15C4,x		; / 
BNE INVALID		; 

LDY #$00		; \ set up loop
LDA $1662,x		;  | 
AND #$20		;  | if not smushed (1662 & 0x20), go through loop twice
BEQ ON_SCREEN_LOOP	;  | else, go through loop once
INY			; / 

ON_SCREEN_LOOP:
LDA $D8,x		; \ 
CLC			;  | set vertical offscreen if necessary
ADC TABLE1,y		;  |
PHP			;  |
CMP $1C			;  | (vert screen boundry)
ROL $00			;  |
PLP			;  |
LDA $14D4,x		;  | 
ADC #$00		;  |
LSR $00			;  |
SBC $1D			;  |
BEQ ON_SCREEN_Y		;  |
LDA $186C,x		;  | (vert offscreen)
ORA TABLE2,y		;  |
STA $186C,x		;  |

ON_SCREEN_Y:
DEY			;  |
BPL ON_SCREEN_LOOP	; /

LDY $15EA,x		; get offset to sprite OAM
LDA $E4,x		; \ 
SEC			;  | 
SBC $1A			;  | $00 = sprite x position relative to screen boarder
STA $00			; / 
LDA $D8,x		; \ 
SEC			;  | 
SBC $1C			;  | $01 = sprite y position relative to screen boarder
STA $01			; / 
RTS			; return

INVALID:
PLA			; \ return from *main gfx routine* subroutine...
PLA			;  |    ...(not just this subroutine)
RTS			; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B829 - vertical mario/sprite position check - shared
; Y = 1 if mario below sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B829 

SUB_VERT_POS:
LDY #$00
LDA $96
SEC
SBC $D8,x
STA $0F
LDA $97
SBC $14D4,x
BPL LABEL11
INY

LABEL11:
RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B817        

SUB_HORZ_POS:
LDY #$00
LDA $94
SEC
SBC $E4,x
STA $0F
LDA $95
SBC $14E0,x
BPL LABEL16
INY

LABEL16:
RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_IS_OFFSCREEN
; After the subroutine, the accumulator will be non zero if the sprite is off screen
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_IS_OFFSCREEN:
LDA $15A0,x
ORA $186C,x
RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B85D - off screen processing code - shared
; sprites enter at different points
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B83B             

TABLE3:
	db $40,$B0
TABLE6:
	db $01,$FF 
TABLE4:
	db $30,$C0,$A0,$80,$A0,$40,$60,$B0 
TABLE5:
	db $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0:
LDA #$06		; \ entry point of routine determines value of $03
BRA STORE_03		;  | 
SUB_OFF_SCREEN_X1:
LDA #$04		;  |
BRA STORE_03		;  |
SUB_OFF_SCREEN_X2:
LDA #$02		;  |
STORE_03:
STA $03			;  |
BRA START_SUB		;  |
SUB_OFF_SCREEN_HB:
STZ $03			; /

START_SUB:
JSR SUB_IS_OFF_SCREEN	; \ if sprite is not off screen, return
BEQ RETURN_2		; /    
LDA $5B			; \  goto VERTICAL_LEVEL if vertical level
AND #$01		;  |
BNE VERTICAL_LEVEL	; /     
LDA $D8,x		; \
CLC			;  | 
ADC #$50		;  | if the sprite has gone off the bottom of the level...
LDA $14D4,x		;  | (if adding 0x50 to the sprite y position would make the high byte >= 2)
ADC #$00		;  | 
CMP #$02		;  | 
BPL ERASE_SPRITE	; /    ...erase the sprite
LDA $167A,x		; \ if "process offscreen" flag is set, return
AND #$04		;  |
BNE RETURN_2		; /
LDA $13			; \ 
AND #$01		;  | 
ORA $03			;  | 
STA $01			;  |
TAY			; /
LDA $1A
CLC
ADC TABLE4,y
ROL $00
CMP $E4,x
PHP
LDA $1B
LSR $00
ADC TABLE5,y
PLP
SBC $14E0,x
STA $00
LSR $01
BCC LABEL20
EOR #$80
STA $00

LABEL20:
LDA $00
BPL RETURN_2

ERASE_SPRITE:
LDA $14C8,x		; \ if sprite status < 8, permanently erase sprite
CMP #$08		;  |
BCC KILL_SPRITE		; /
LDY $161A,x
CPY #$FF
BEQ KILL_SPRITE
LDA #$00		; \ mark sprite to come back
STA $1938,y		; /

KILL_SPRITE:
STZ $14C8,x		; erase sprite

RETURN_2:
RTS

VERTICAL_LEVEL:
LDA $167A,x		; \ if "process offscreen" flag is set, return
AND #$04		;  |
BNE RETURN_2		; /
LDA $13			; \ only handle every other frame??
LSR A			;  | 
BCS RETURN_2		; /
AND #$01
STA $01
TAY
LDA $1C
CLC
ADC TABLE3,y
ROL $00
CMP $D8,x
PHP
LDA.w $001D
LSR $00
ADC TABLE6,y
PLP
SBC $14D4,x
STA $00
LDY $01
BEQ LABEL22
EOR #$80
STA $00

LABEL22:
LDA $00
BPL RETURN_2
BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN:
LDA $15A0,x		; \ if sprite is on screen, accumulator = 0 
ORA $186C,x		;  |  
RTS			; / return

NOP